<template>
    <div class="auth-wrapper text-center">
        <main class="form-signin">
            <form @submit="onLogin" class="main-form">
                <img class="mb-4 form-img" src="../assets/images/poke-ball.png" alt="" width="72" height="57">
                <h1 class="h3 mb-3 fw-normal">Pokemon Enthusiast Portal</h1>

                <div class="form-floating">
                    <input v-model="email" type="email" class="form-control" id="floatingInput"
                        placeholder="name@example.com" required>
                    <label for="floatingInput">Email address</label>
                </div>
                <div class="form-floating">
                    <input v-model="password" type="password" class="form-control" id="floatingPassword"
                        placeholder="Password" required>
                    <label for="floatingPassword">Password</label>
                </div>
                <br>
                <button type="submit" class="mb-2 w-100 btn btn-lg btn-primary btn-form-action">Sign in</button>
            </form>
            <br>
            <p>Doesn't have an account? <a @click="register" class="text-primary">Click here to register</a></p>
            <p class="mt-5 mb-3 text-muted">
                Designed and Developed by <a href="https://gabrielarellano.tech/" target="blank">
                    <img src="https://gabrielarellano.tech/wp-content/uploads/2022/12/default-logo.png"
                        class="footer-logo">
                </a>
            </p>
        </main>
    </div>
</template>

<script>
export default {
    name: "LoginView",
    data() {
        return {
            email: "",
            password: "",
        }
    },
    created(){
        this.token = localStorage.getItem("pokemon-bearer-token");
        if (this.token) {
            this.$router.push('/dashboard') 
        }
    },
    methods: {
        
        onLogin(e) {
            e.preventDefault();
            const loginAttempt = {
                email: this.email,
                password: this.password,
            }

            if (this.email && this.password) {
                this.login(loginAttempt);
            }
            else {
                alert('Unable to process request')
            }
        },
        async login(credentials) {
            const res = await fetch('http://localhost:8000/api/login', {
                method: 'POST',
                headers: {
                    'Content-Type': 'application/json',
                    'Accept': 'application/json',
                },
                body: JSON.stringify(credentials)
            })

            const data = await res.json()
            


            if (("token" in data)) {
                localStorage.setItem("pokemon-bearer-token", data.token);
                this.$router.push('/dashboard') 
            }
            else{
                alert(data.messsage)
            }
        },

        register(){
            this.$router.push('register') 
        }
    },
    emit: ['login-attempt']
}
</script>